/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package data;

import java.util.Scanner;
import program.persisten.FileCheck;

/**
 *
 * @author dfoxpro
 */
public class Config {

    private String version;
    private String savePath;
    private String dataPath;
    private String repositoryPath;
    private boolean fullscreen;

    public Config(String version) {
        this.version = version;
        this.repositoryPath = "http://www.f-d4-cb.com/";
        this.fullscreen = false;
        new FileCheck().checkConf(this);
    }

    public void setValue(String aLine) {
        //use a second Scanner to parse the content of each line
        Scanner scanner = new Scanner(aLine);
        scanner.useDelimiter("=");
        if (scanner.hasNext()) {
            String typeValue = scanner.next();
            String value = scanner.next();
            if (typeValue.equals("version")) {
                this.version = value;
            } else if (typeValue.equals("fullscreen")) {
                this.fullscreen = Boolean.getBoolean(value);
            } else if (typeValue.equals("savePath")) {
                this.savePath = value;
            } else if (typeValue.equals("dataPath")) {
                this.dataPath = value;
            } else if (typeValue.equals("repositoryPath")) {
                this.repositoryPath = value;
            }
        } else {
            System.err.println("Empty or invalid line. Unable to process.");
        }
        scanner.close();
    }

    public String getDataPath() {
        return dataPath;
    }

    public void setDataPath(String dataPath) {
        this.dataPath = dataPath;
    }

    public boolean isFullscreen() {
        return fullscreen;
    }

    public void setFullscreen(boolean fullscreen) {
        this.fullscreen = fullscreen;
    }

    public String getRepositoryPath() {
        return repositoryPath;
    }

    public void setRepositoryPath(String repositoryPath) {
        this.repositoryPath = repositoryPath;
    }

    public String getSavePath() {
        return savePath;
    }

    public void setSavePath(String savePath) {
        this.savePath = savePath;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    @Override
    public String toString() {
        return "Config: "
                + "version:"+this.version
                + "; savePath:"+this.savePath
                + "; dataPath:"+this.dataPath
                + "; repositoryPath:"+this.repositoryPath
                + "; fullscreen:"+this.fullscreen
                + ".\n";
    }
}
