/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gameRules;

import java.util.ArrayList;

/**
 *
 * @author dfoxpro
 */
public class PlayerCharacter {

    private String owner = "";
    private String name = "";
    private int lvl = 1;
    private String clas = "";
    private String paragonPath = "";
    private String epicPath = "";
    private String race = "";
    private String size = "";
    private int age = 0;
    private String gender = "";
    private int height = 0;
    private int weight = 0;
    private String alignment = "";
    private String deity = "";
    private String adventuringCompany = "";
    private ArrayList<String> extraClassStads = new ArrayList();
    private ArrayList<String> extraRaceStads = new ArrayList();
    private ArrayList<String> languajes = new ArrayList();
    private ArrayList<Skill> skills = new ArrayList();
    private ArrayList<String> knowedSkills = new ArrayList();
    private ArrayList powers = new ArrayList();
    private int maxHp;
    private int surgesPDay;
    private int maxSkills;
    private int speed;
    private int actionPoints = 1;
    private int str = 8;
    private int con = 8;
    private int dex = 8;
    private int inte = 8;
    private int wis = 8;
    private int cha = 8;
    private int bnStr;
    private int bnCon;
    private int bnDex;
    private int bnInt;
    private int bnWis;
    private int bnCha;
    private int defAC;
    private int bnClassAC;
    private int bnFeatAC;
    private int bnMisAC;
    private int bnEnhAC;
    private int defWill;
    private int bnClassWill;
    private int bnRaceWill;
    private int bnFeatWill;
    private int bnMisWill;
    private int bnEnhWill;
    private int defRef;
    private int bnClassRef;
    private int bnFeatRef;
    private int bnMisRef;
    private int bnEnhRef;
    private int defFort;
    private int bnClassFort;
    private int bnFeatFort;
    private int bnMisFort;
    private int bnEnhFort;
    Skill skl = new Skill(this);//¬¬

    public PlayerCharacter() {
        if (this.languajes.size() == 0) {
            languajes.add("");//# extra languaje
            languajes.add("Common");
            languajes.add("");
        }
        if (this.extraClassStads.size() == 0) {
            extraClassStads.add("");
            extraClassStads.add("");
        }
        if (this.knowedSkills.size() == 0) {
            knowedSkills.add("");
            knowedSkills.add("");
        }
        if (this.extraRaceStads.size() == 0) {
            extraRaceStads.add("");
            extraRaceStads.add("");
        }
        this.clas = "";
        skl.initSkills();
    }

    public String getAling() {
        return alignment;
    }

    public void setAlignment(String aling) {
        this.alignment = aling;
    }

    public int getCha() {
        return cha;
    }

    public void setCha(int cha) {
        this.cha = cha;
        skl.updateSkills("cha");
        setDefWill();
    }

    public String getClas() {
        return clas;
    }

    public void setClas(String arg) {
        this.clas = arg;
        setDef();
        setMaxHp();
        setSurgesPDay();
    }

    public int getCon() {
        return con;
    }

    public void setCon(int arg) {
        this.con = (arg);
        setSurgesPDay();
        setMaxHp();
        skl.updateSkills("con");
        setDefFort();
    }

    public int getDefAC() {
        return defAC;
    }

    public void setDefAC(int defAC) {
        this.defAC = defAC;
    }

    public int getDefFort() {
        return defFort;
    }

    public void setDefFort() {
        int a;
        if (str < con) {
            a = scoreModifier(con);
        } else {
            a = scoreModifier(str);
        }
        this.defFort = (10 + (lvl / 2) + a + bnClassFort + bnFeatFort + bnMisFort + bnEnhFort);
    }

    public int getDefRef() {
        return defRef;
    }

    public void setDefRef() {
        int a;
        if (dex < inte) {
            a = scoreModifier(inte);
        } else {
            a = scoreModifier(dex);
        }
        this.defRef = (10 + (lvl / 2) + a + bnClassRef + bnFeatRef + bnMisRef + bnEnhRef);
    }

    public int getDefWill() {
        return defWill;
    }

    public void setDefWill() {
        int a;
        if (wis < cha) {
            a = scoreModifier(cha);
        } else {
            a = scoreModifier(wis);
        }
        this.defWill = (10 + (lvl / 2) + a + bnRaceWill + bnClassWill + bnFeatWill + bnMisWill + bnEnhWill);
    }

    public String getDeity() {
        return deity;
    }

    public void setDeity(String deity) {
        this.deity = deity;
    }

    public int getDex() {
        return dex;
    }

    public void setDex(int dex) {
        this.dex = dex;
        skl.updateSkills("dex");
        setDefRef();
    }

    public String getGender() {
        return gender;
    }

    public void setGender(String gender) {
        this.gender = gender;
    }

    public int getInte() {
        return inte;
    }

    public void setInte(int inte) {
        this.inte = inte;
        skl.updateSkills("int");
        setDefRef();
    }

    public int getLvl() {
        return lvl;
    }

    public void setLvl(int lvl) {
        this.lvl = lvl;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public String getRace() {
        return race;
    }

    public void setRace(String arg) {
        race = arg;
        size = "M";
        bnStr = 0;
        bnCon = 0;
        bnDex = 0;
        bnInt = 0;
        bnWis = 0;
        bnCha = 0;

        bnRaceWill = 0;
        speed = 6;
        if (race.equals("Dragonborn")) {
            bnStr = 2;
            bnCha = 2;
        } else if (race.equals("Dwarf")) {
            speed = 5;
            bnCon = 2;
            bnWis = 2;
        } else if (race.equals("Eladrin")) {
            bnDex = 2;
            bnInt = 2;
            bnRaceWill = 1;
        } else if (race.equals("Elf")) {
            speed = 7;
            bnDex = 2;
            bnWis = 2;
        } else if (race.equals("Half-Elf")) {
            bnCon = 2;
            bnCha = 2;
        } else if (race.equals("Halfling")) {
            size = "S";
            bnDex = 2;
            bnCha = 2;
        } else if (race.equals("Tiefling")) {
            bnInt = 2;
            bnCha = 2;
        }
        setSkills();
        setLanguajes();
    }

    public int getStr() {
        return str;
    }

    public void setStr(int str) {
        this.str = str;
        skl.updateSkills("str");
        setDefFort();
    }

    public int getWis() {
        return wis;
    }

    public int scoreModifier(int arg) {
        return ((arg / 2) - 5);
    }

    public void setWis(int wis) {
        this.wis = wis;
        skl.updateSkills("wis");
        setDefWill();
    }

    public int getBnCha() {
        return bnCha;
    }

    public void setBnCha(int bnCha) {
        this.bnCha = bnCha;
    }

    public int getBnCon() {
        return bnCon;
    }

    public void setBnCon(int bnCon) {
        this.bnCon = bnCon;
    }

    public int getBnClassAC() {
        return bnClassAC;
    }

    public void setBnClassAC(int arg) {
        this.bnClassAC = arg;
    }

    public int getBnDefFort() {
        return bnClassFort;
    }

    public void setBnDefFort(int bnDefFort) {
        this.bnClassFort = bnDefFort;
    }

    public int getBnDefRef() {
        return bnClassRef;
    }

    public void setBnDefRef(int bnDefRef) {
        this.bnClassRef = bnDefRef;
    }

    public int getBnDefWill() {
        return bnClassWill;
    }

    public void setBnDefWill(int bnDefWill) {
        this.bnClassWill = bnDefWill;
    }

    public int getBnDex() {
        return bnDex;
    }

    public void setBnDex(int bnDex) {
        this.bnDex = bnDex;
    }

    public int getBnInt() {
        return bnInt;
    }

    public void setBnInt(int bnInt) {
        this.bnInt = bnInt;
    }

    public int getBnStr() {
        return bnStr;
    }

    public void setBnStr(int bnStr) {
        this.bnStr = bnStr;
    }

    public int getBnWis() {
        return bnWis;
    }

    public void setBnWis(int bnWis) {
        this.bnWis = bnWis;
    }

    public ArrayList getLanguajes() {
        return languajes;
    }

    public void set2ndLanguaje(String arg) {
        this.languajes.set(2, arg);
    }

    public void setLanguajes() {
        if (getRace().equals("Dragonborn")) {
            set2ndLanguaje("Draconic");
        } else if (getRace().equals("Dwarf")) {
            set2ndLanguaje("Dwarven");
        } else if (getRace().equals("Eladrin")) {
            set2ndLanguaje("Elven");
        } else if (getRace().equals("Elf")) {
            set2ndLanguaje("Elven");
        } else {
            this.languajes.set(2, "");
            this.languajes.set(0, "1");//1 extra languaje
        }
    }

    public void setHAS(String s) {
        if (extraRaceStads.size() == 0) {
            extraRaceStads.add("");
        }
        bnStr = 0;
        bnCon = 0;
        bnDex = 0;
        bnInt = 0;
        bnWis = 0;
        bnCha = 0;

        if (s.equals("Strengh")) {
            bnStr = 2;
        } else if (s.equals("Constitution")) {
            bnCon = 2;
        } else if (s.equals("Dexterity")) {
            bnDex = 2;
        } else if (s.equals("Inteligence")) {
            bnInt = 2;
        } else if (s.equals("Wisdow")) {
            bnWis = 2;
        } else if (s.equals("Charisma")) {
            bnCha = 2;
        }
        extraRaceStads.set(0, s);
        setMaxHp();
    }

    void setDef() {
        bnClassAC = 0;
        bnClassFort = 0;
        bnClassRef = 0;
        bnClassWill = 0;
        if (clas.equals("Cleric")) {
            bnClassWill = 2;
        } else if (clas.equals("Fighter")) {
            bnClassFort = 2;
        } else if (clas.equals("Paladin")) {
            bnClassFort = 1;
            bnClassWill = 1;
            bnClassRef = 1;
        } else if (clas.equals("Ranger")) {
            bnClassFort = 1;
            bnClassRef = 1;
        } else if (clas.equals("Rouge")) {
            bnClassRef = 2;
        } else if (clas.equals("Warlord")) {
            bnClassFort = 1;
            bnClassWill = 1;
        } else if (clas.equals("Warlock")) {
            bnClassWill = 1;
            bnClassRef = 1;
        } else if (clas.equals("Wizard")) {
            bnClassWill = 2;
        }
        setDefFort();
        setDefRef();
        setDefWill();
    }

    public int getMaxHp() {
        return maxHp;
    }

    public void setMaxHp() {
        if (clas.equals("Cleric")) {
            maxHp = (12 + (con));
            maxHp += (lvl - 1) * 5;
        } else if (clas.equals("Fighter")) {
            maxHp = (15 + (con));
            maxHp += (lvl - 1) * 6;
        } else if (clas.equals("Paladin")) {
            maxHp = (15 + (con));
            maxHp += (lvl - 1) * 6;
        } else if (clas.equals("Ranger")) {
            maxHp = (12 + (con));
            maxHp += (lvl - 1) * 5;
        } else if (clas.equals("Rouge")) {
            maxHp = (12 + (con));
            maxHp += (lvl - 1) * 5;
        } else if (clas.equals("Warlord")) {
            maxHp = (12 + (con));
            maxHp += (lvl - 1) * 5;
        } else if (clas.equals("Warlock")) {
            maxHp = (12 + (con));
            maxHp += (lvl - 1) * 5;
        } else if (clas.equals("Wizard")) {
            maxHp = (10 + (con));
            maxHp += (lvl - 1) * 4;
        }
    }

    public int getSurgesPDay() {
        return surgesPDay;
    }

    public void setSurgesPDay() {
        // TODO: A corregiur: sacar las reglas de este metodo: DB
        if (clas.equals("Cleric")) {
            this.surgesPDay = (7 + scoreModifier(con));
        } else if (clas.equals("Fighter")) {
            this.surgesPDay = (9 + scoreModifier(con));
        } else if (clas.equals("Paladin")) {
            this.surgesPDay = (10 + scoreModifier(con));
        } else if (clas.equals("Ranger")) {
            this.surgesPDay = (6 + scoreModifier(con));
        } else if (clas.equals("Rouge")) {
            this.surgesPDay = (6 + scoreModifier(con));
        } else if (clas.equals("Warlord")) {
            this.surgesPDay = (7 + scoreModifier(con));
        } else if (clas.equals("Warlock")) {
            this.surgesPDay = (6 + scoreModifier(con));
        } else if (clas.equals("Wizard")) {
            this.surgesPDay = (6 + scoreModifier(con));
        }
    }

    public ArrayList getExtraClassStads() {
        return extraClassStads;
    }

    public void setExtraClassStads(int index, String arg) {
        this.extraClassStads.set(index, arg);
    }

    public ArrayList getExtraRaceStads() {
        return extraRaceStads;
    }

    public void setExtraRaceStads(int index, String arg) {
        this.extraRaceStads.add(index, arg);
    }

    public int getInitiative() {
        int b = scoreModifier(dex) + (getLvl() / 2);
        return b;
    }

    public int getSurgesValue() {
        return maxHp / 4;
    }

    public int getPassivePerseption() {
        Skill a = (Skill) skills.get(12);
        return 10 + a.getBonus();
    }

    public int getSpeed() {
        return speed;
    }

    public void setSpeed(int speed) {
        this.speed = speed;
    }

    public int getPassiveInsight() {
        Skill a = (Skill) skills.get(9);
        return 10 + a.getBonus();
    }

    public Skill getSkill(int arg) {
        Skill r = skills.get(arg);
        return r;
    }

    public void setSkills(ArrayList skills) {
        this.skills = skills;
    }

    public int getMaxSkills() {
        return maxSkills;
    }

    public void setMaxSkills(int maxSkills) {
        this.maxSkills = maxSkills;
    }

    public void setSkills() {
        maxSkills = 0;
        skl.defineSkills();
    }

    public ArrayList<Skill> getSkills() {
        return skills;
    }

    public int getActionPoints() {
        return actionPoints;
    }

    public void setActionPoints(int actionPoints) {
        this.actionPoints = actionPoints;
    }

    public String getAdventuringCompany() {
        return adventuringCompany;
    }

    public void setAdventuringCompany(String adventuringCompany) {
        this.adventuringCompany = adventuringCompany;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public String getEpicPath() {
        return epicPath;
    }

    public void setEpicPath(String epicPath) {
        this.epicPath = epicPath;
    }

    public int getHeight() {
        return height;
    }

    public void setHeight(int height) {
        this.height = height;
    }

    public String getParagonPath() {
        return paragonPath;
    }

    public void setParagonPath(String paragonPath) {
        this.paragonPath = paragonPath;
    }

    public String getSize() {
        return size;
    }

    public void setSize(String size) {
        this.size = size;
    }

    public int getWeight() {
        return weight;
    }

    public void setWeight(int weight) {
        this.weight = weight;
    }

    public void upgradeSkills() {
//        throw new UnsupportedOperationException("Not yet implemented");
    }

    public String getKnowedSkills(int index) {
        return knowedSkills.get(index);
    }

    public void setKnowedSkills(String arg, int index) {
        this.knowedSkills.set(index, arg);
    }
}